/******************************************
	PURPOSE:	Piranha Plant library
	Created by      Aldo Reigosa
	DATE:		11/2014
*******************************************/
#include "Arduino.h"                                                                          // We again include the Arduino library to use the Arduino functions.
#include "Plant.h"                                                                            // This is where we include the header where we defined the functions and variables.

//********************************************************************************************

// This is were we define what the functions actually do and how the variables are implememted
// Basically, this is where the actual programming is stored.

//********************************************************************************************

Piranha::Piranha(int EchoPin, int TriggerPin)                                                // The constructor
{
  _TriggerPin= TriggerPin;                                                                   // Here is where we define what the EchoPin and TriggerPin is for the other functions to use
  _EchoPin= EchoPin;                                                                          
  pinMode(EchoPin, INPUT);                                                                   // This is the basic assignment of the pins for the HCSR04 proximity sensor
  pinMode(TriggerPin, OUTPUT);
}

float Piranha::readSensor()                                                                  // This function will tell us the distance of an object in centimeters
{

  digitalWrite(_TriggerPin, HIGH);                                                           // This turns on the TriggerPin
  delayMicroseconds(10);                                                                     // This is the delay in Microseconds
  digitalWrite(_TriggerPin, LOW);                                                            // This turns off the TriggerPin
  
  int distance = pulseIn(_EchoPin,HIGH);                                                     // Here we calculate the distance according to the amount of time required for the EchoPin to 
                                                                                             // receive the bounced back signal of the TriggerPin
                                                                                             
  distance = distance/58;                                                                    // This is the formula for the actual distance according the the recorded distance in centimeters                                                                        // This will set the _distance to the current distance so when readSensor() runs again it will
                                                                                             // set the last recorded value of _distance as _lastValue and update the current value
  
  return distance;                                                                           // This will give us the value that we are seeking from this function
}


